/*C**************************************************************************
* $RCSfile: main.c,v $
*----------------------------------------------------------------------------
* Copyright (c) 2002 Atmel.
*----------------------------------------------------------------------------
* RELEASE:      $Name: avr-can11-lib-mcu-0_0_3 $      
* REVISION:     $Revision: 1.3 $     
* FILE_CVSID:   $Id: main.c,v 1.3 2004/03/29 11:10:00 jberthy Exp $       
*----------------------------------------------------------------------------
* PURPOSE: 
* This file contains an example of use the CAN library
* 
*****************************************************************************/

/*_____ I N C L U D E S ____________________________________________________*/

#include "config.h"
#include "can_lib.h"
#include "display.h"
#include <avr/io.h>
#include <stdlib.h>
#include <stdio.h>

#define setbit(ADDRESS,BIT) (ADDRESS |= (1<<BIT))
#define clearbit(ADDRESS,BIT) (ADDRESS &= ~(1<<BIT))


/*_____ M A C R O S ________________________________________________________*/

/*_____ D E F I N I T I O N S ______________________________________________*/
/*_____ D E C L A R A T I O N S ____________________________________________*/
#define lichtan() setbit(PORTG,PG1)
 char displaystring[16]; 

void display_first_line(void)
{
display_cursor(1,1);
display_string("               ");	 
display_cursor(1,1);
sprintf(displaystring,"%x%x%x %x %x %X", CANIDT1,CANIDT2,CANIDT3,CANGCON,CANCDMOB,CANSTMOB);
display_string(displaystring);	 
}

void loop_back_without_interrupt_Receive(void)
{


 Uchar buffer[8];
  st_cmd_t msg;     // message descriptor store in code area

 //w display_cursor(1,1);
 //w display_string("CanTest->Receive");

  msg.pt_data = &buffer[0];
//  msg.status = 0;
//  msg.handle = 0;


 Can_clear_all_MOB();
 

//   CANPAGE  = (0 << 4);
   
 
  do{ //do while muss raus wenn spter zu gebrauchen
  
//	display_clear();

	
	msg.cmd     = CMD_RX;

	 
    while(can_cmd(&msg) != CAN_CMD_ACCEPTED);

	display_first_line();  
        
     while(can_getstatus(&msg) != CAN_STATUS_COMPLETED);
  
    display_cursor(2,1);
    display_string(msg.pt_data);
	

	
    
	
//   if (msg.ctrl.rtr){ msg.cmd = CMD_TX_REMOTE;}
//   else             { msg.cmd = CMD_TX;       }

//    while(can_cmd(&msg) != CAN_CMD_ACCEPTED);
//    while(can_getstatus(&msg) != CAN_STATUS_COMPLETED);
/*
    display_cursor(2,1);
    display_string(msg.pt_data);
*/
  }while(1);
}

void loop_back_without_interrupt_send(char *sendString,int MsgID)
{
//  Uchar tab[5]={0x42, 0x42, 0x42, 0x42, 0x00};
  Uchar tab[8];
  
  strcpy(tab,sendString);
  
  st_cmd_t msg;     // message descriptor store in code area
  

  display_cursor(2,1);
  display_string(sendString);

//  msg.id.std  = 0x003;
//  msg.id.ext  = 0x0012345;
  msg.id.ext  = MsgID;
 

 
  msg.pt_data = &tab[0];
  msg.status  = 0;
  msg.handle  = 0;
  msg.dlc     = strlen(sendString);




//  do{
    msg.cmd     = CMD_TX;

    while(can_cmd(&msg) != CAN_CMD_ACCEPTED);
	display_first_line(); 
	
    while(can_getstatus(&msg) != CAN_STATUS_COMPLETED);
/*
    if (msg.ctrl.rtr){ msg.cmd = CMD_TX_REMOTE;}
    else             { msg.cmd = CMD_TX;       }

    while(can_cmd(&msg) != CAN_CMD_ACCEPTED);
    while(can_getstatus(&msg) != CAN_STATUS_COMPLETED);
*/
//  }while(1);
}



/*F**************************************************************************
* NAME: main 
*----------------------------------------------------------------------------
* PARAMS:   none
* return:   none
*----------------------------------------------------------------------------
* PURPOSE: 
*----------------------------------------------------------------------------
* EXAMPLE:
*----------------------------------------------------------------------------
* NOTE: 
*----------------------------------------------------------------------------
* REQUIREMENTS: 
*****************************************************************************/
int main (void)
{	
  char displaystring[16];


 display_init(); 

  can_init();
 
  clearbit(PORTD,PD7);										// PD7 High Can disable
  setbit(DDRD,DDD7);										// PD7 als Augang setzen CAN Enable 	
//	CLKPR = 0x80;
//	CLKPR = 0x07;	



  lichtan();    
// loop_back_without_interrupt_Receive();
///*
  display_cursor(1,1);
  display_string("CanTest->Send");

  while(1)
  {
   loop_back_without_interrupt_send("DennisLA",4128);
   for (long t=0;t<800000;t++) asm("NOP");
   loop_back_without_interrupt_send("Wolfgang",14399);
   for (long t=0;t<800000;t++) asm("NOP");
   loop_back_without_interrupt_send("Jascha  ",16447);
   for (long t=0;t<800000;t++) asm("NOP");
   loop_back_without_interrupt_send("TexSolar",32831);
   for (long t=0;t<800000;t++) asm("NOP");
  }
//*/ 
  return 0;
}

/*F**************************************************************************
* NAME: loop_back_without_interrupt 
*----------------------------------------------------------------------------
* PARAMS:   none
* return:   none
*----------------------------------------------------------------------------
* PURPOSE: 
*----------------------------------------------------------------------------
* EXAMPLE:
*----------------------------------------------------------------------------
* NOTE: 
*----------------------------------------------------------------------------
* REQUIREMENTS: 
*****************************************************************************/
